#ifndef _INCLUDE_GUARD_STRUCTURE_H_
#define _INCLUDE_GUARD_STRUCTURE_H_

#include <linux/time.h>
#include <linux/wait.h>


struct http_request;

struct http_request
{
	/* Linked list */
	struct http_request *Next;

	/* Network and File data */
	struct socket	*sock;
	struct file	*filp;

	int		FileLength;
	int		Time;
	int		IMS_Time;
	int		BytesSent;
	int		Done;

	/* Wait queue */

	wait_queue_t sleep;


	/* Request information */
	int		IsForUserspace;
	char		TimeS[64];
	char		LengthS[14];
	char		*MimeType;
	int		MimeLength;
	int		HTTPVER;         /* 9 for 0.9,   10 for 1.0 and above */


	char		FileName[256];
	int		FileNameLength;
	char		Agent[128];
	char		IMS[128];
	char		Host[128];
};


struct http_time
{
	time_t 	UnixTime;
	char	MimeTime[256];
};

struct khttpd_threadinfo
{
	struct http_request* WaitForHeaderQueue;
	struct http_request* DataSendingQueue;
	struct http_request* LoggingQueue;
	struct http_request* UserspaceQueue;
	char  dummy[16];  /* Padding for cache-lines */
};

#endif
